require 'helper'

class TestLogFile < MiniTest::Unit::TestCase
  def setup
    @file = AssemblyPipe::VelvetOptimiser::LogFile.open("test/data/test_logfile.txt")
  end
  
  def test_open
    assert_equal AssemblyPipe::VelvetOptimiser::LogFile, @file.class
  end

  def test_date
    assert_equal "06/24", @file.date.strftime("%m/%d") 
  end

  def test_velveth_runs
    assert_equal 1, @file.velveth_runs.first["Assembly id"]
    assert_equal 25, @file.velveth_runs.first["Velvet hash value"]
    assert_equal 1150179650, @file.velveth_runs.first["Roadmap file size"]
    assert_equal 20, @file.velveth_runs.count
  end

  def test_vanilla_velvetg_runs
    assert_equal 3057, @file.vanilla_velvetg_runs.first['Assembly score']
    assert_equal 30018, @file.vanilla_velvetg_runs.first['length of longest contig']
    assert_equal 8787270, @file.vanilla_velvetg_runs.to_a.last['Total bases in contigs']
  end

  def test_final_assembly
    assert_equal 3, @file.final_assembly['Assembly id']
    assert_equal 28278189, @file.final_assembly['Assembly score']
    assert_equal 28278189, @file.final_assembly['Total bases in contigs > 1k']
  end

  def test_summary_table
    File.open("test/test.txt", 'w'){|f| f.puts @file.summary_table }
  end
end
